import 'package:dyte_core/dyte_core.dart';
import 'package:dyte_core_example/models/states/participant_event_states.dart';
import 'package:dyte_core_example/models/states/room_event_states.dart';
import 'package:dyte_core_example/notifiers/chat_notifier.dart';
import 'package:dyte_core_example/notifiers/local_user_notifier.dart';
import 'package:dyte_core_example/notifiers/participant_state_notifier.dart';
import 'package:dyte_core_example/notifiers/pin_unpin_notifier.dart';
import 'package:dyte_core_example/notifiers/plugin_state_notifier.dart';
import 'package:dyte_core_example/notifiers/poll_notifier.dart';
import 'package:dyte_core_example/notifiers/recording_notifier.dart';
import 'package:dyte_core_example/notifiers/room_state_notifier.dart';
import 'package:dyte_core_example/notifiers/router_notifier.dart';
import 'package:dyte_core_example/notifiers/screenshare_notifier.dart';
import 'package:dyte_core_example/notifiers/states/chat_states.dart';
import 'package:dyte_core_example/notifiers/states/local_user_states.dart';
import 'package:dyte_core_example/notifiers/states/poll_states.dart';
import 'package:dyte_core_example/notifiers/states/router_states.dart';
import 'package:dyte_core_example/notifiers/states/waitlisted_participant_states.dart';
import 'package:dyte_core_example/notifiers/waitlisted_participant_notifier.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'di.dart';

final localUserSettingsProvider =
    NotifierProvider<LocalUserNotifer, LocalUserState>(
  () {
    return LocalUserNotifer(localUserSettingsRepository);
  },
  name: 'localUserSettingsProvider',
);

final roomEventNotifier = NotifierProvider<RoomStateNotifier, RoomEventStates>(
  () => RoomStateNotifier(),
  name: 'roomEventNotifier',
);

final participantEventNotifier =
    NotifierProvider<ParticipantNotifier, ParticipantEventStates>(
  () => ParticipantNotifier(),
  name: 'participantEventNotifier',
);

final pinUnpinProvider =
    NotifierProvider<PinNotifier, DyteMeetingParticipant?>(PinNotifier.new);

final screenshareProvider =
    NotifierProvider<ScreenshareNotifier, List<DyteMeetingParticipant>>(
        ScreenshareNotifier.new);

final pluginProvider =
    NotifierProvider<PluginNotifer, List<DytePlugin>>(PluginNotifer.new);
final chatNotifier =
    StateNotifierProvider<ChatNotifier, ChatStates>((ref) => ChatNotifier());

final recordingNotifier =
    NotifierProvider<RecordingNotifer, DyteRecordingState>(
        RecordingNotifer.new);

final waitingRoomNotifier =
    NotifierProvider<WaitingRoomNotifer, WaitlistedParticipantStates>(
        () => WaitingRoomNotifer());

final routerNotifier = NotifierProvider<RouterNotifier, RouterStates>(
  () => RouterNotifier(),
);

final newPollEventNotifier = NotifierProvider<NewPollNotifer, PollStates>(
  () => NewPollNotifer(),
);

final pollsListNotifier =
    NotifierProvider<PollListNotifier, List<DytePollMessage>>(
        PollListNotifier.new);
